From Coq Require Import ssreflect.
From fcsl Require Import options.

Inductive sched := ChoiceAct | SeqRet | SeqStep of sched |
                   ParRet | ParL of sched | ParR of sched |
                   MorfRet | MorfStep of sched.

(* an alternative inductions on schedules *)
(* to group together common cases for ParL and ParR *)

Lemma sched_ind' (P : sched -> Prop) :
       P ChoiceAct ->
       P SeqRet ->
       (forall s, P s -> P (SeqStep s)) ->
       P ParRet ->
       (forall s, P s -> P (ParL s) /\ P (ParR s)) ->
       P MorfRet ->
       (forall s, P s -> P (MorfStep s)) ->
       forall s, P s.
Proof. by move=>H1 H2 H3 H4 H5 H6 H7; elim=>// s; case/H5. Qed.
